diff --git a/src/main/java/net/minecraft/client/render/RenderGlobal.java b/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 7e9751ea6..1fdd7fd59 100644
--- a/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -1179,20 +1179,20 @@ public class RenderGlobal
                 rendererList.sort(comparator);
             }
             for (ChunkRenderer renderer : rendererList){
-                renderer.updateRenderer();
-                renderer.needsUpdate = false;
+                renderer.rebuild();
+                renderer.dirty = false;
             }
         }
         int renderersUpdated = 0;
         for(int layer = numLayers - 1; layer >= 0; layer--) {
             ChunkRenderer renderer = chunkRenderers[layer];
             if(renderer == null) { continue; }
-            if(!renderer.isInFrustum && layer != numLayers - 1) {
+            if(!renderer.visible && layer != numLayers - 1) {
                 chunkRenderers[layer] = null;
                 break;
             }
-            renderer.updateRenderer();
-            renderer.needsUpdate = false;
+            renderer.rebuild();
+            renderer.dirty = false;
             renderersUpdated++;
         }
 
@@ -1222,19 +1222,19 @@ public class RenderGlobal
     public void drawBlockBreaking(ICamera camera, HitResult hitResult, float partialTick)
     {
         Tessellator tessellator = Tessellator.instance;
-        GL11.glEnable(3042 /*GL_BLEND*/);
-        GL11.glEnable(3008 /*GL_ALPHA_TEST*/);
+        GL11.glEnable(GL11.GL_BLEND);
+        GL11.glEnable(GL11.GL_ALPHA_TEST);
         GL11.glBlendFunc(770, 1);
         GL11.glColor4f(1.0F, 1.0F, 1.0F, (MathHelper.sin((float)System.currentTimeMillis() / 100F) * 0.2F + 0.4F) * 0.5F);
         if(damagePartialTime > 0.0F)
         {
             GL11.glBlendFunc(774, 768);
-            TextureRegistry.blockAtlas.bindTexture();
+            TextureRegistry.blockAtlas.bind();
             GL11.glColor4f(1.0F, 1.0F, 1.0F, 0.5F);
             GL11.glPushMatrix();
             int k = worldObj.getBlockId(hitResult.x, hitResult.y, hitResult.z);
             Block block = k <= 0 ? null : Block.blocksList[k];
-            GL11.glDisable(3008 /*GL_ALPHA_TEST*/);
+            GL11.glDisable(GL11.GL_ALPHA_TEST);
             GL11.glPolygonOffset(-3F, -3F);
             GL11.glEnable(32823 /*GL_POLYGON_OFFSET_FILL*/);
             double x = camera.getX(partialTick);
@@ -1242,9 +1242,9 @@ public class RenderGlobal
             double z = camera.getZ(partialTick);
             if(block == null)
             {
-                block = Block.stone;
+                block = Blocks.STONE;
             }
-            GL11.glEnable(3008 /*GL_ALPHA_TEST*/);
+            GL11.glEnable(GL11.GL_ALPHA_TEST);
             tessellator.startDrawingQuads();
             tessellator.setTranslation(-x, -y, -z);
             tessellator.lockColor();
@@ -1252,27 +1252,27 @@ public class RenderGlobal
             BlockModelDispatcher.getInstance().getDispatch(block).renderWithOverrideTexture(tessellator, hitResult.x, hitResult.y, hitResult.z, breakingAnimation[MathHelper.clamp((int)(damagePartialTime * 10F), 0, breakingAnimation.length)] );
             tessellator.draw();
             tessellator.setTranslation(0.0D, 0.0D, 0.0D);
-            GL11.glDisable(3008 /*GL_ALPHA_TEST*/);
+            GL11.glDisable(GL11.GL_ALPHA_TEST);
             GL11.glPolygonOffset(0.0F, 0.0F);
             GL11.glDisable(32823 /*GL_POLYGON_OFFSET_FILL*/);
-            GL11.glEnable(3008 /*GL_ALPHA_TEST*/);
+            GL11.glEnable(GL11.GL_ALPHA_TEST);
             GL11.glDepthMask(true);
             GL11.glPopMatrix();
         }
-        GL11.glDisable(3042 /*GL_BLEND*/);
-        GL11.glDisable(3008 /*GL_ALPHA_TEST*/);
+        GL11.glDisable(GL11.GL_BLEND);
+        GL11.glDisable(GL11.GL_ALPHA_TEST);
     }
 
     public void drawSelectionBox(ICamera camera, HitResult hitResult, float partialTick)
     {
         if (mc.gameSettings.immersiveMode.drawOutline() && mc.gameSettings.blockOutlineWidth.value > 0.01f && !(mc.currentScreen instanceof GuiModelViewer))
         {
-            GL11.glEnable(3042 /*GL_BLEND*/);
+            GL11.glEnable(GL11.GL_BLEND);
             GL11.glBlendFunc(GL11.GL_SRC_ALPHA, GL11.GL_ONE_MINUS_SRC_ALPHA);
             float w = mc.getOutlineWidth();
             GL11.glColor4f(0.0F, 0.0F, 0.0F, 0.35f + w * 0.3f);
             GL11.glLineWidth(java.lang.Math.max(4.0f * w * 2.0f, 1.0f));
-            GL11.glDisable(3553 /*GL_TEXTURE_2D*/);
+            GL11.glDisable(GL11.GL_TEXTURE_2D);
             GL11.glDepthMask(false);
             double offsetX = camera.getX(partialTick);
             double offsetY = camera.getY(partialTick);
@@ -1292,7 +1292,7 @@ public class RenderGlobal
                     else
                     {
                         Block.blocksList[j].setBlockBoundsBasedOnState(worldObj, hitResult.x, hitResult.y, hitResult.z);
-                        drawOutlinedBoundingBox(Block.blocksList[j].getSelectedBoundingBoxFromPool(worldObj, hitResult.x, hitResult.y, hitResult.z).expand(expand, expand, expand).getOffsetBoundingBox(-offsetX, -offsetY, -offsetZ));
+                        drawOutlinedBoundingBox(Block.blocksList[j].getSelectedBoundingBoxFromPool(worldObj, hitResult.x, hitResult.y, hitResult.z).grow(expand, expand, expand).cloneMove(-offsetX, -offsetY, -offsetZ));
                     }
                 }
             }
@@ -1302,8 +1302,8 @@ public class RenderGlobal
             }
 
             GL11.glDepthMask(true);
-            GL11.glEnable(3553 /*GL_TEXTURE_2D*/);
-            GL11.glDisable(3042 /*GL_BLEND*/);
+            GL11.glEnable(GL11.GL_TEXTURE_2D);
+            GL11.glDisable(GL11.GL_BLEND);
         }
     }
     
@@ -1315,10 +1315,10 @@ public class RenderGlobal
 		double offsetY = camera.getY(partialTicks);
 		double offsetZ = camera.getZ(partialTicks);
 		float expand = 0.002F;
-		List<AABB> collidingBoundingBoxes = worldObj.getCubes(mc.thePlayer, mc.thePlayer.bb.expand(expand, expand, expand));
+		List<AABB> collidingBoundingBoxes = worldObj.getCubes(mc.thePlayer, mc.thePlayer.bb.grow(expand, expand, expand));
 		glColor4f(0.0f, 0.0f, 1.0f, 1.0f);
 		for (AABB aabb : collidingBoundingBoxes) {
-			drawOutlinedBoundingBox(aabb.getOffsetBoundingBox(-offsetX, -offsetY, -offsetZ).expand(expand, expand, expand));
+			drawOutlinedBoundingBox(aabb.cloneMove(-offsetX, -offsetY, -offsetZ).grow(expand, expand, expand));
 		}
 
 		glColor4f(1.0f, 1.0f, 1.0f, 1.0f);
@@ -1326,7 +1326,7 @@ public class RenderGlobal
 		if(mc.thePlayer.getGamemode() == Gamemode.creative) {
 			entityRadius = 100.0f;
 		}
-		List<Entity> entitiesNearby = worldObj.getEntitiesWithinAABBExcludingEntity(mc.thePlayer, mc.thePlayer.bb.expand(entityRadius, entityRadius, entityRadius));
+		List<Entity> entitiesNearby = worldObj.getEntitiesWithinAABBExcludingEntity(mc.thePlayer, mc.thePlayer.bb.grow(entityRadius, entityRadius, entityRadius));
 		for (Entity e : entitiesNearby) {
 			drawInterpolatedEntityBoundingBox(e, camera, partialTicks);
 		}
@@ -1343,10 +1343,10 @@ public class RenderGlobal
         double lerpOffsetY = entity.yo + (entity.y - entity.yo) * partialTicks;
         double lerpOffsetZ = entity.zo + (entity.z - entity.zo) * partialTicks;
         AABB boundingBox = entity.bb;
-        boundingBox = boundingBox.expand(expand, expand, expand);
-        boundingBox = boundingBox.getOffsetBoundingBox(-entity.x, -entity.y, -entity.z);
-        boundingBox = boundingBox.getOffsetBoundingBox(-cameraX, -cameraY, -cameraZ);
-        boundingBox = boundingBox.getOffsetBoundingBox(lerpOffsetX, lerpOffsetY, lerpOffsetZ);
+        boundingBox = boundingBox.grow(expand, expand, expand);
+        boundingBox = boundingBox.cloneMove(-entity.x, -entity.y, -entity.z);
+        boundingBox = boundingBox.cloneMove(-cameraX, -cameraY, -cameraZ);
+        boundingBox = boundingBox.cloneMove(lerpOffsetX, lerpOffsetY, lerpOffsetZ);
         drawOutlinedBoundingBox(boundingBox);
     }
 
@@ -1361,8 +1361,8 @@ public class RenderGlobal
 		Tessellator tessellator = Tessellator.instance;
 		tessellator.setTranslation(-offsetX, -offsetY, -offsetZ);
 		
-		int blockX = MathHelper.floor_double(mc.thePlayer.x);
-		int blockZ = MathHelper.floor_double(mc.thePlayer.z);
+		int blockX = MathHelper.floor(mc.thePlayer.x);
+		int blockZ = MathHelper.floor(mc.thePlayer.z);
 
 		int chunkX = blockX >> 4;
         int chunkZ = blockZ >> 4;
@@ -1513,10 +1513,10 @@ public class RenderGlobal
                     }
                     int i = (realWrZ * renderChunksTall + realWrY) * renderChunksWide + realWrX;
                     ChunkRenderer worldrenderer = chunkRenderers[i];
-                    if(!worldrenderer.needsUpdate)
+                    if(!worldrenderer.dirty)
                     {
                         chunkRenderersToUpdate.add(worldrenderer);
-                        worldrenderer.markDirty();
+                        worldrenderer.setDirty();
                     }
                 }
             }
@@ -1539,9 +1539,9 @@ public class RenderGlobal
     {
         for(int i = 0; i < chunkRenderers.length; i++)
         {
-            if(!chunkRenderers[i].skipAllRenderPasses() && (!chunkRenderers[i].isInFrustum || (i + frustumCheckOffset & 0xf) == 0))
+            if(!chunkRenderers[i].isEmpty() && (!chunkRenderers[i].visible || (i + frustumCheckOffset & 0xf) == 0))
             {
-                chunkRenderers[i].updateInFrustum(frustum, partialTick);
+                chunkRenderers[i].cull(frustum, partialTick);
             }
         }
 
@@ -1573,7 +1573,7 @@ public class RenderGlobal
         }
         if(mc.activeCamera.distanceToSqr(x, y, z) < (double)(soundDistance * soundDistance))
         {
-            mc.sndManager.playSound(soundPath, category, (float)x, (float)y, (float)z, volume, pitch);
+            mc.sndManager.playSoundAt(soundPath, category, (float)x, (float)y, (float)z, volume, pitch);
         }
     }
     
@@ -1597,7 +1597,7 @@ public class RenderGlobal
         {
             return;
         }
-        EntityFX fx = ParticleDispatcher.getInstance().getDispatch(particleId).newParticle(worldObj, x, y, z, motionX, motionY, motionZ, data);
+        Particle fx = ParticleDispatcher.getInstance().getDispatch(particleId).newParticle(worldObj, x, y, z, motionX, motionY, motionZ, data);
         if (fx != null){
             mc.effectRenderer.addEffect(fx);
         }
@@ -1610,16 +1610,16 @@ public class RenderGlobal
 		}
 		if(seasonChanged || lightChanged && !LightmapHelper.isLightmapEnabled()) {
 			for(ChunkRenderer chunkRenderer : chunkRenderers) {
-				if(chunkRenderer.isChunkLit && !chunkRenderer.needsUpdate) {
+				if(chunkRenderer.skyLit && !chunkRenderer.dirty) {
 					chunkRenderersToUpdate.add(chunkRenderer);
-					chunkRenderer.markDirty();
+					chunkRenderer.setDirty();
 				}
 			}
 		}
 	}
 
     @Override
-    public void tileEntityChanged(int x, int y, int z, TileEntity tileEntity)
+    public void tileEntityChanged(int x, int y, int z, BlockEntity blockEntity)
     {
     }
 
@@ -1630,7 +1630,7 @@ public class RenderGlobal
         }
     }
     @Override
-    public void levelEvent(EntityPlayer player, int id, int x, int y, int z, int data)
+    public void levelEvent(Player player, int id, int x, int y, int z, int data)
     {
         Random random = worldObj.rand;
         switch(id) {
@@ -1690,8 +1690,8 @@ public class RenderGlobal
                 break;
 
             case EVENT_JUKEBOX_TOGGLE: // Jukebox play/stop record
-                if(Item.itemsList[data] instanceof ItemRecord) {
-                    ItemRecord record = ((ItemRecord)Item.itemsList[data]);
+                if(Item.itemsList[data] instanceof MusicDiscItem) {
+                    MusicDiscItem record = ((MusicDiscItem)Item.itemsList[data]);
                     worldObj.playRecord(record.recordName, record.recordAuthor, x, y, z);
                 } else {
                     worldObj.playRecord(null, null, x, y, z);
@@ -1714,7 +1714,7 @@ public class RenderGlobal
 	public void entityRemoved(Entity entity) {
 	}
 
-    public List<TileEntity> tileEntities;
+    public List<BlockEntity> tileEntities;
     private World worldObj;
     private final RenderEngine renderEngine;
     private final List<ChunkRenderer> chunkRenderersToUpdate;
diff --git a/src/main/java/net/minecraft/client/render/Vertex.java b/src/main/java/net/minecraft/client/render/Vertex.java
index e1ecec97c..4193a1d79 100644
--- a/src/main/java/net/minecraft/client/render/Vertex.java
+++ b/src/main/java/net/minecraft/client/render/Vertex.java
@@ -1,39 +1,33 @@
 package net.minecraft.client.render;
 
-
-// Referenced classes of package net.minecraft.src:
-//            Vec3D
-
-import net.minecraft.core.util.phys.Vec3d;
+import net.minecraft.core.util.phys.Vec3;
 
 public class Vertex
 {
+    public Vec3 pos;
+    public float u;
+    public float v;
 
-    public Vertex(float f, float f1, float f2, float f3, float f4)
+    public Vertex(float x, float y, float z, float u, float v)
     {
-        this(Vec3d.createVectorHelper(f, f1, f2), f3, f4);
+        this(Vec3.getPermanentVec3(x, y, z), u, v);
     }
 
-    public Vertex setTexturePosition(float f, float f1)
-    {
-        return new Vertex(this, f, f1);
+    public Vertex(Vertex vertex, float u, float v) {
+        pos = vertex.pos;
+        this.u = u;
+        this.v = v;
     }
 
-    public Vertex(Vertex positiontexturevertex, float f, float f1)
-    {
-        vector3D = positiontexturevertex.vector3D;
-        texturePositionX = f;
-        texturePositionY = f1;
+    public Vertex(Vec3 vec3, float u, float v) {
+        pos = vec3;
+        this.u = u;
+        this.v = v;
     }
 
-    public Vertex(Vec3d vec3d, float f, float f1)
+    public Vertex remap(float u, float v)
     {
-        vector3D = vec3d;
-        texturePositionX = f;
-        texturePositionY = f1;
+        return new Vertex(this, u, v);
     }
 
-    public Vec3d vector3D;
-    public float texturePositionX;
-    public float texturePositionY;
 }
